function matrixToGraph2(A,width,length,statecolor,b)
%function matrixToGraph(A,map,vL)
% convert a connectivity matrix to a graph
% input: A = matrix, map = colormap, vL = vertex locations
A=2*A;
if nargin<4, statecolor=1;b=1;end

n = size(A,1);
d=2*pi/n/20;
if (nargin<6)
    xL = 2*pi/n * (1:n);
    vLp = [cos(xL+d);sin(xL+d)];
    vLm = [cos(xL-d);sin(xL-d)];
end
if (nargin<2)
    width = 1;
end
if (nargin<3)
    length = 15;
end

thres=0;
for j=1:n
    for i=1:j
        if i<j
         if 1
            magAij=abs(A(i,j)); magAij=magAij*(magAij>(thres*.5*max(max(A-diag(diag(A))))));
            magAji=abs(A(j,i)); magAji=magAji*(magAji>(thres*.5*max(max(A-diag(diag(A))))));
            arrow(vLp(:,i),.95*vLm(:,j)+.05*vLp(:,i),7,'Length',length*magAij^.5,'BaseAngle',[],'TipAngle',[],'Width',width*magAij,'EdgeColor',colmapfunction(A(i,j),statecolor,b),'FaceColor',colmapfunction(A(i,j),statecolor,b));
            arrow(vLp(:,j),.95*vLm(:,i)+.05*vLp(:,j),7,'Length',length*magAji^.5,'BaseAngle',[],'TipAngle',[],'Width',width*magAji,'EdgeColor',colmapfunction(A(j,i),statecolor,b),'FaceColor',colmapfunction(A(j,i),statecolor,b));   
         else
            magAij=A(i,j)*1;
            magAji=A(j,i)*1;
            s=.2;        
            line((1-s)*[vLm(1,j);vLp(1,i)]+s*[vLp(1,i);vLm(1,j)],(1-s)*[vLm(2,j);vLp(2,i)]+s*[vLp(2,i);vLm(2,j)],'LineWidth',magAij)
            line((1-s)*[vLp(1,j);vLm(1,i)]+s*[vLm(1,i);vLp(1,j)],(1-s)*[vLp(2,j);vLm(2,i)]+s*[vLm(2,i);vLp(2,j)],'LineWidth',magAji)
         end
         end
    end
end

