function matrixToGraphPhi(A,width,length,color,seq)
%function matrixToGraph(A,map,vL)
% convert a connectivity matrix to a graph
% input: A = matrix, map = colormap, vL = vertex locations

if nargin<4, statecolor=1;end

n = size(A,1);
d=2*pi/n/20;
if (nargin<7)
    xL = 2*pi/n * (1:n) +2*pi/size(A,1)/2;
    vLp = [cos(xL+d);sin(xL+d)];
    vLm = [cos(xL-d);sin(xL-d)];
end
if (nargin<2)
    width = 1;
end
if (nargin<3)
    length = 15;
end

s=.35;
%A=.3*A/max(max(abs(A)));
%A=8*A;
%axis([-1.25,1.25,-1,1])
for i=1:n
    %i=seq(ii);
    for j=1:n
        %j=seq(jj);
        if i<j
            magAij=A(seq(i),seq(j)).^2;
            magAji=A(seq(j),seq(i)).^2;
            %arrow(vLp(:,i),vLm(:,j),7,'Length',length*magAij^.5,'BaseAngle',[],'TipAngle',[],'Width',width*magAij,'EdgeColor',colmapfunction(A(i,j),statecolor,b),'FaceColor',colmapfunction(A(i,j),statecolor,b));
            %arrow(vLp(:,j),vLm(:,i),7,'Length',length*magAji^.5,'BaseAngle',[],'TipAngle',[],'Width',width*magAji,'EdgeColor',colmapfunction(A(j,i),statecolor,b),'FaceColor',colmapfunction(A(j,i),statecolor,b));
            if 1
                if magAij>0
                    arrow(s*vLm(:,j)+(1-s)*vLp(:,i),(1-s)*vLm(:,j)+s*vLp(:,i),7,'Length',min(length*magAij^.5,75),'BaseAngle',[],'TipAngle',[],'Width',min(width*magAij,15),'EdgeColor',color,'FaceColor',color);
                end
                if magAji>0
                    arrow(s*vLm(:,i)+(1-s)*vLp(:,j),(1-s)*vLm(:,i)+s*vLp(:,j),7,'Length',min(length*magAji^.5,75),'BaseAngle',[],'TipAngle',[],'Width',min(width*magAji,15),'EdgeColor',color,'FaceColor',color);
                end
            else
                line((1-s)*[vLm(1,j);vLp(1,i)]+s*[vLp(1,i);vLm(1,j)],(1-s)*[vLm(2,j);vLp(2,i)]+s*[vLp(2,i);vLm(2,j)],'LineWidth',magAij)
                line((1-s)*[vLp(1,j);vLm(1,i)]+s*[vLm(1,i);vLp(1,j)],(1-s)*[vLp(2,j);vLm(2,i)]+s*[vLm(2,i);vLp(2,j)],'LineWidth',magAji)
            end
        end
    end
end