function matrixToGraphX2(A0,A,width,length,statecolor)
%function matrixToGraph(A,map,vL)
% convert a connectivity matrix to a graph
% input: A = matrix, map = colormap, vL = vertex locations

if nargin<5, statecolor=1;end

n = size(A,1);
d=2*pi/n/20;
if (nargin<7)
    xL = 2*pi/n * (1:n);
    vLp = [cos(xL+d);sin(xL+d)];
    vLm = [cos(xL-d);sin(xL-d)];
end
if (nargin<3)
    width = .5;
end 
if (nargin<4)
    length = 15;
end

thres=0; 
A=A/norm(A,1)*40; A0=A0/norm(A0,1)*40;
for i=1:n
    for j=1:n
        if i<j
            magAij=A(i,j);%min(abs(A(i,j)),3);%*2.5;
            magAji=A(j,i);%min(abs(A(j,i)),3);%*2.5;
            %arrow(vLp(:,i),vLm(:,j),7,'Length',length*magAij^.5,'BaseAngle',[],'TipAngle',[],'Width',width*magAij,'EdgeColor',colmapfunction(A(i,j),statecolor,b),'FaceColor',colmapfunction(A(i,j),statecolor,b));
            %arrow(vLp(:,j),vLm(:,i),7,'Length',length*magAji^.5,'BaseAngle',[],'TipAngle',[],'Width',width*magAji,'EdgeColor',colmapfunction(A(j,i),statecolor,b),'FaceColor',colmapfunction(A(j,i),statecolor,b));
            if 1
                magAij=(A0(i,j)-A(i,j)); 
                magAijr=magAij./(A(i,j)+A0(i,j)+1);
                magAji=(A0(j,i)-A(j,i));
                magAjir=magAji./(A(j,i)+A0(j,i)+1);
                
                %magAij=min(abs(A(i,j)),30);
                %magAji=min(abs(A(j,i)),30);
                % magAij=abs(A(i,j)); magAij=magAij*(magAij>(thres*.5*max(max(A-diag(diag(A))))));
                % magAji=abs(A(j,i)); magAji=magAji*(magAji>(thres*.5*max(max(A-diag(diag(A))))));
                %cc=(1-max(A(i,j)-A0(i,j),0)./(A(i,j)+A0(i,j))).^.5;
                if magAij<0
                    magAij=-magAij;
                    cc=0.0;
                    if magAijr<.75, cc=0;end
                else
                %cc=max(min(magAij/(A(i,j)+A0(i,j)),1),.1);
                cc=max(magAij,0);
                end; %cc=cc.^.5;
                arrow(vLp(:,i),.95*vLm(:,j)+.05*vLp(:,i),7,'Length',length*magAij^.5,'BaseAngle',[],'TipAngle',[],'Width',width*magAij,'EdgeColor',colmapfunction(cc,statecolor,min(1.25+magAijr,1)),'FaceColor',colmapfunction(cc,statecolor,min(1.25+magAijr,1)));
                %cc=(1-max(A(j,i)-A0(j,i),0)./(A0(j,i)+A0(j,i))).^.5;
                if magAji<0
                    magAji=-magAji;
                    %cc=1-min(magAji/(A(j,i)+A0(j,i)),1);
                    cc=0.0;
                    if magAjir<.75, cc=0;end
                else
                %cc=max(min(magAji/(A(i,j)+A0(i,j)),1),.1);
                cc=max(magAji,0); 
                end; %cc=cc.^.5;
                arrow(vLp(:,j),.95*vLm(:,i)+.05*vLp(:,j),7,'Length',length*magAji^.5,'BaseAngle',[],'TipAngle',[],'Width',width*magAji,'EdgeColor',colmapfunction(cc,statecolor,min(1.+magAjir,1)),'FaceColor',colmapfunction(cc,statecolor,min(1.+magAjir,1)));
            else
                magAij=A(i,j)*1;
                magAji=A(j,i)*1;
                s=.2;
                line((1-s)*[vLm(1,j);vLp(1,i)]+s*[vLp(1,i);vLm(1,j)],(1-s)*[vLm(2,j);vLp(2,i)]+s*[vLp(2,i);vLm(2,j)],'LineWidth',magAij)
                line((1-s)*[vLp(1,j);vLm(1,i)]+s*[vLm(1,i);vLp(1,j)],(1-s)*[vLp(2,j);vLm(2,i)]+s*[vLm(2,i);vLp(2,j)],'LineWidth',magAji)
            end
        end
    end
end

